com.io7m.r2.core.shaders.types

## Class R2ShaderParametersMaterial.Builder<M>

- java.lang.Object
- - com.io7m.r2.core.shaders.types.R2ShaderParametersMaterial.Builder<M>

- Enclosing class:
    R2ShaderParametersMaterial<M>

      public static final class R2ShaderParametersMaterial.Builder<M>
      extends Object

  Builds instances of type `R2ShaderParametersMaterial`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

  `Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `R2ShaderParametersMaterial<M>` | `build()` Builds a new `R2ShaderParametersMaterial`.
    `R2ShaderParametersMaterial.Builder<M>` | `from(R2ShaderParametersMaterialType<M> instance)` Fill a builder with attribute values from the provided `R2ShaderParametersMaterialType` instance.
    `R2ShaderParametersMaterial.Builder<M>` | `setTextureUnitContext(com.io7m.jcanephora.texture_unit_allocator.JCGLTextureUnitContextMutableType textureUnitContext)` Initializes the value for the `textureUnitContext` attribute.
    `R2ShaderParametersMaterial.Builder<M>` | `setValues(M values)` Initializes the value for the `values` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### from

          public final R2ShaderParametersMaterial.Builder<M> from(R2ShaderParametersMaterialType<M> instance)

      Fill a builder with attribute values from the provided `R2ShaderParametersMaterialType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
      Parameters:
        `instance` - The instance from which to copy values
      Returns:
        `this` builder for use in a chained invocation

    - #### setTextureUnitContext

          public final R2ShaderParametersMaterial.Builder<M> setTextureUnitContext(com.io7m.jcanephora.texture_unit_allocator.JCGLTextureUnitContextMutableType textureUnitContext)

      Initializes the value for the `textureUnitContext` attribute.
      Parameters:
        `textureUnitContext` - The value for textureUnitContext
      Returns:
        `this` builder for use in a chained invocation

    - #### setValues

          public final R2ShaderParametersMaterial.Builder<M> setValues(M values)

      Initializes the value for the `values` attribute.
      Parameters:
        `values` - The value for values
      Returns:
        `this` builder for use in a chained invocation

    - #### build

          public R2ShaderParametersMaterial<M> build()

      Builds a new `R2ShaderParametersMaterial`.
      Returns:
        An immutable instance of R2ShaderParametersMaterial
      Throws:
        `IllegalStateException` - if any required attributes are missing

Copyright © 2016 <code@io7m.com> http://io7m.com